SystemOrganization addCategory: #'Glamour-Morphic'!

Announcer subclass: #GLMMorphicModel
	instanceVariableNames: 'glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicModel subclass: #GLMButtonModel
	instanceVariableNames: 'glamourAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:25'!
buttonLabel
	^ self glamourAction title! !

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:35'!
execute
	self glamourAction actOn: self glamourPresentation! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction
	^ glamourAction! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction: anObject
	glamourAction := anObject! !

GLMMorphicModel subclass: #GLMListModel
	instanceVariableNames: 'items selection displaySelector searchText searchBlock singleSelection filterBlock filteredItems menuBlock dynamicMenu onSelectionBlock selectedIndexes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMListModel methodsFor: 'accessing' stamp: 'tg 7/31/2009 23:00'!
canonicalItems
	^ items! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 9/9/2009 01:04'!
displayListAt: anIndex
	^ self glamourPresentation formatedDisplayValueOf: (self items at: anIndex)! !

!GLMListModel methodsFor: 'accessing' stamp: 'david_roethlisberger 3/2/2009 11:03'!
displaySelector: aSymbol
	displaySelector := aSymbol! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 7/31/2009 23:20'!
displayedItems
	^ self items collect: [:each | displaySelector glamourValue: each]
! !

!GLMListModel methodsFor: 'associating' stamp: 'jre 8/1/2009 13:22'!
doSearch
	searchText isEmptyOrNil
		ifTrue: [ self executeReset ]
		ifFalse:[ 
			searchBlock isNil 
				ifTrue: [ self executeFilter ]
				ifFalse: [ self executeSearch ] ].
		
	! !

!GLMListModel methodsFor: 'associating' stamp: 'jre 8/1/2009 13:22'!
executeFilter
	filteredItems := filterBlock value: self searchText asString value: self canonicalItems.
	self changed: #displayedItems; changed: #selection
	! !

!GLMListModel methodsFor: 'associating' stamp: 'a'!
executeReset
	filteredItems := self canonicalItems.
	self changed: #items; changed: #selection
	! !

!GLMListModel methodsFor: 'associating' stamp: 'tg 9/27/2009 17:06'!
executeSearch
	| searchResult |
	searchResult := searchBlock 
		value: self searchText asString
		value: self canonicalItems.
	selectedIndexes := ((1 to: self canonicalItems size) select: [ :eachIndex | searchResult includes: (self canonicalItems at: eachIndex) ]) asOrderedCollection.
	onSelectionBlock ifNotNil: [ onSelectionBlock value: searchResult ].
	self changed: #allSelections! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 7/31/2009 23:00'!
filterBlock: aBlock
	filterBlock := aBlock! !

!GLMListModel methodsFor: 'initialization' stamp: 'tg 7/31/2009 22:39'!
initialize
	super initialize.
	selection := 0.
	searchText := ''
	"searchBlock := [:text :list | OrderedCollection new]"! !

!GLMListModel methodsFor: 'testing' stamp: 'tg 8/1/2009 20:06'!
isMultiple
	^ self selectedIndexes isNil not! !

!GLMListModel methodsFor: 'accessing' stamp: 'jre 8/1/2009 13:20'!
items
	^ filteredItems! !

!GLMListModel methodsFor: 'accessing' stamp: 'JorgeRessia 11/6/2009 17:05'!
items: aCollection
	| nonSetCollection |
	nonSetCollection := (aCollection isKindOf: Set) ifTrue: [aCollection asOrderedCollection] ifFalse: [aCollection].
	items := nonSetCollection.
	filteredItems := nonSetCollection.
	self changed: #displayedItems! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 7/31/2009 23:23'!
listAt: anIndex
	^ self items at: anIndex! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 20:06'!
listSelectionAt: anIndex 
	^ self selectedIndexes includes: anIndex! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 20:48'!
listSelectionAt: anIndex put: aValue 
	aValue = true
		ifTrue: [ (self selectedIndexes includes: anIndex) ifFalse: [ self selectedIndexes add: anIndex ] ]
		ifFalse: [ self selectedIndexes remove: anIndex ifAbsent: [  ] ].
	onSelectionBlock ifNotNil: [
		onSelectionBlock value: self selectedItems ].
	self changed: #selection! !

!GLMListModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 10:54'!
listSize
	^self items size! !

!GLMListModel methodsFor: 'updating' stamp: 'tg 8/1/2009 19:57'!
onSelection: aBlock 
	onSelectionBlock := aBlock! !

!GLMListModel methodsFor: 'accessing' stamp: 'jorge.ressia 5/26/2009 12:19'!
searchBlock: aBlock
	searchBlock := aBlock! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 5/20/2009 14:43'!
searchEnabled
	^ true! !

!GLMListModel methodsFor: 'accessing' stamp: 'a'!
searchText
	^ searchText! !

!GLMListModel methodsFor: 'accessing' stamp: 'a'!
searchText: aString
	searchText := aString.
	self doSearch
! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 9/9/2009 02:24'!
selectItem: anObject 
	| index |
	index := 0.
	self items withIndexDo: [:each :i | each == anObject ifTrue: [index := i]].
	selection := index.
	self changed: #singleSelection.! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 8/1/2009 20:07'!
selectedIndexes
	"this only holds the indexes of the selected items in terms of the entire collection of items"
	^ selectedIndexes ifNil: [ selectedIndexes := OrderedCollection new ]! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 02:13'!
selectedIndexes: aCollection
	selectedIndexes := aCollection! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 8/1/2009 20:49'!
selectedItems
	"This holds the collection of the actual selected items. It must be in sync with the selectedIndexes"
	^  self items species withAll: (self selectedIndexes collect: [ :eachIndex | self listAt: eachIndex ])! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 7/31/2009 22:51'!
selection 
	^ selection! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 19:59'!
selection: anIndex
	selection := anIndex. 
	self changed: #selection.! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 7/31/2009 22:51'!
singleSelection 
	^ selection! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 20:03'!
singleSelection: anIndex 
	self flag: 'What is the difference between singleSelection and selection?'.
	anIndex == 0 ifFalse: 
		[ selection := anIndex.
		onSelectionBlock ifNotNil: [ onSelectionBlock value: (self listAt: anIndex) ] ].
	self changed: #singleSelection! !

GLMListModel subclass: #GLMMultiListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMultiListModel methodsFor: 'as yet unclassified' stamp: 'tg 10/2/2009 01:22'!
selectItem: aCollection
	| indexes |
	indexes := OrderedCollection new.
	self items withIndexDo: [:each :i | 
		aCollection asOrderedCollection do: [:anObject |
			each == anObject ifTrue: [indexes add: i]
		]
	].
	self selectedIndexes: indexes.
	self changed: #displayedItems.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:26'!
allKeystrokeActions
	^ self glamourPresentation allActions select: [:action | action hasShortcut ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:24'!
allMenuActions
	^ self glamourPresentation allActions select: [:action | action hasTitle ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'jre 7/31/2009 09:48'!
executeMenuAction: anAction
	self announce: (GLMMenuItemSelected action: anAction)! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation
	^ glamourPresentation! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMMorphicModel methodsFor: 'initialization' stamp: 'tg 8/4/2009 15:26'!
initialize
	super initialize.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:26'!
keystroke: aChar from: aMorph
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aChar] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ].! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 9/8/2009 14:46'!
menu: aMenuMorph 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

GLMMorphicModel subclass: #GLMTextModel
	instanceVariableNames: 'text highlightSmalltalk highlightSmalltalkContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/7/2009 02:03'!
accept: aText notifying: anObject 
	aText asString withBlanksTrimmed ifEmpty: [^self].
	text := aText.
	self changed: #text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk
	^ highlightSmalltalk! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk: anObject
	highlightSmalltalk := anObject! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext
	^ highlightSmalltalkContext! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext: anObject
	highlightSmalltalkContext := anObject! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 3/2/2009 16:22'!
keystroke: anEvent from: aMorph
	anEvent anyModifierKeyPressed ifTrue: [super keystroke: anEvent keyCharacter from: aMorph]! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:31'!
menu: aMorphMenu shifted: b
	^ self menu: aMorphMenu! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 5/14/2009 22:10'!
selectSilently: anIndex
	self changed: #selection! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
selection
	^ 1 to: 0! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:42'!
shoutAboutToStyle: aPluggableShoutMorph
	self highlightSmalltalk ifFalse: [^ false].
	self highlightSmalltalkContext notNil ifTrue: [
		aPluggableShoutMorph classOrMetaClass: self highlightSmalltalkContext].
	^ true! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
text
	^text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 11:51'!
text: aTextOrString
	text := aTextOrString! !

GLMMorphicModel subclass: #GLMTreeModel
	instanceVariableNames: 'roots selection childrenBlock onSelection displaySelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:24'!
childrenBlock
	^childrenBlock! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:24'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'tg 5/6/2009 10:56'!
displaySelector: aSymbol
	displaySelector := aSymbol! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:56'!
geSelectionPath
	^self selection! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'tg 9/6/2009 16:11'!
getChildrenOf: aNode
	^childrenBlock isNil 
		ifTrue: [OrderedCollection new]
		ifFalse: [childrenBlock glamourValue: aNode]! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'tg 9/9/2009 01:29'!
getLabelOf: anObject
	^ self glamourPresentation formatedDisplayValueOf: anObject! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:32'!
hasChildren: aNode
	^(self getChildrenOf: aNode) notEmpty! !

!GLMTreeModel methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 14:12'!
nodeAt: pathCollection
	^self nodeAt: pathCollection allButFirst for: self roots! !

!GLMTreeModel methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 14:26'!
nodeAt: pathCollection for: childrenCollection
	| node |
	node := childrenCollection at: pathCollection first.
	^pathCollection size > 1 ifTrue: [self nodeAt: pathCollection allButFirst for: (childrenBlock value: node)] ifFalse: [node]! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:38'!
onSelection: aBlock
	onSelection := aBlock! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:54'!
roots
	^roots! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:22'!
roots: aCollectionOrElement
	roots := aCollectionOrElement isCollection ifTrue: [aCollectionOrElement] ifFalse: [OrderedCollection with: aCollectionOrElement]! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 13:57'!
selection
	^selection! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:39'!
selection: aNode
     selection := aNode.
	onSelection ifNotNil: [onSelection value: aNode].
	self changed: #selection.! !

RectangleMorph subclass: #GLMPaneScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:43'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: ''!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPaneScroller methodsFor: 'private' stamp: 'jorge.ressia 5/25/2009 16:25'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'jorge.ressia 5/25/2009 16:29'!
initialize
	super initialize.
	self 
		color: Color white;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	paneCount := 0.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: ''!
initializeScrollbar
	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'david_roethlisberger 3/18/2009 14:26'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
innerBounds
	| rect |
	rect := super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
isScrollable
	^ self leftoverScrollRange > 0! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
layoutWidgets
	| inner outer |
	outer := super innerBounds.
	inner := self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom)
						corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!GLMPaneScroller methodsFor: 'configuration' stamp: 'david_roethlisberger 3/18/2009 15:05'!
maxPanes
	^2! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'jorge.ressia 5/25/2009 16:18'!
paneCount
	^ paneCount! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneHeight
	^ transform bounds height! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
pushPane: aMorph	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
resizeScrollBar
	| inner outer |
	outer := super innerBounds.
	inner := outer withHeight: outer height - self scrollBarHeight.
	scrollBar bounds: ((inner left @ inner bottom) corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
scrollBarHeight
	^ self theme scrollbarThickness! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!GLMPaneScroller methodsFor: 'input events' stamp: ''!
scrollBarMenuButtonPressed: anObject! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollDeltaWidth
	^ 1! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollToRight
	^ scrollBar setValue: 1.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
separator
	^ BorderedSubpaneDividerMorph vertical
		adoptPaneColor: self paneColor;
		yourself! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:28'!
separatorWidth
	^3! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!GLMPaneScroller methodsFor: 'accessing' stamp: 'david_roethlisberger 3/18/2009 14:27'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'jorge.ressia 5/25/2009 16:40'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

ListItemWrapper subclass: #GLMTreeMorphNodeModel
	instanceVariableNames: 'parentNode contents containerTree onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 9/30/2009 01:41'!
buttonForTag: each 
	| button |
	button := GLMMorphicLibrary togglingButtonLabelled: each pressed: (self containerTree shouldFilterByTag: each).
	button
		target: self;
		actionSelector: #toggleFilteringByTag:;
		arguments: (Array with: each).
	^ button! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 11/6/2009 19:35'!
childrenItems
	self flag: 'the commented code should work, but the problem is that it returns nil instead of empty collection'.
	^  (self containerTree childrenBlock glamourValue: self item)
	"(self containerTree glamourPresentation childrenValueOf: self item)"! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree
	^ containerTree! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree: anObject
	containerTree := anObject! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/19/2009 12:43'!
contents
	| allContents |
	^ contents ifNil: 
		[ allContents := self childrenItems collect: [ :d | 
			(self class with: d)
				parentNode: self;
				containerTree: self containerTree;
				yourself ].
		contents := allContents select: [ :each | each shouldBeDisplayed ] ]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 00:59'!
displayText
	^ UITheme current 
		newTextIn: World
		text: (self containerTree glamourPresentation formatedDisplayValueOf: self item) ! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'alain.plantec 9/8/2009 14:37'!
enabled
	^ true! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/16/2009 23:39'!
executeMenuAction: anAction
	self containerTree announce: (GLMMenuItemSelected action: anAction)! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 11/2/2009 01:19'!
expandParentPath
"	self openItemPath: anArray"
	self containerTree changed: {#roots. #openItemPath}, (self path collect: [:each | each item]).! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:54'!
icon
	^ self containerTree glamourPresentation iconFor: self item! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/8/2009 21:09'!
keyStroke: aCharacter from: aTreeMorph 
	^ false
! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 11/2/2009 01:10'!
menu: aMenuMorph shifted: b 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self containerTree allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode
	^ parentNode! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode: aNode
	parentNode := aNode
	! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
path
	^ self pathIn: OrderedCollection new.! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 12:44'!
pathIn: aCollection 
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!GLMTreeMorphNodeModel methodsFor: 'printing' stamp: 'tg 9/9/2009 13:30'!
printOn: aStream
	aStream nextPutAll: 'a NodeModel with '.
	aStream nextPutAll: self item printString.! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:27'!
rowMorphListFor: aContainer 
	| row |
	row := OrderedCollection with: (UITheme current newRowIn: World for: { self displayText }).
	(self containerTree glamourPresentation tagsFor: self item) do: [ :each | 
			row addLast: (self buttonForTag: each) ].
	^ row! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 9/30/2009 01:17'!
shouldBeDisplayed
	^ self shouldBeDisplayedByTags and: [ self shouldBeDisplayedByText ]! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 10/2/2009 12:54'!
shouldBeDisplayedByTags
	| nodeTags |
	self containerTree tagsToFilterBy isEmpty ifTrue: [ ^ true ].
	self withContentsDo: [ :node | 
		nodeTags := self containerTree glamourPresentation tagsFor: node item.
		(self containerTree tagsToFilterBy allSatisfy: [ :each | nodeTags includes: each ])
			ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 9/30/2009 01:17'!
shouldBeDisplayedByText
	self containerTree shouldFilterByText ifFalse: [ ^ true ].
	self withContentsDo: 
		[ :node | 
		self flag: 'this should be delegated to the presentation
		and glamourValue should be used to include the entity ports'.
		(self containerTree glamourPresentation filterStrategy 
			value: self containerTree inputText asString
			value: node item) == true ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:33'!
toggleFilteringByTag: aTag 
	self containerTree toggleFilteringByTag: aTag! !

!GLMTreeMorphNodeModel methodsFor: 'enumerating' stamp: 'tg 9/9/2009 13:42'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicRenderer commentStamp: 'tg 5/24/2009 21:22' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTableLayoutBrowser new.
browser column: #one; column: #two.

browser showOn: #one; using: [browser list.].
browser showOn: #two; from: #one; using: [
	browser text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'factory' stamp: ''!
emptyMorph
	^ RectangleMorph new
		layoutPolicy: ProportionalLayout new;
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		yourself! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 8/4/2009 15:27'!
installActionsOnUI: aMorphicModel fromPresentation: aPresentation	 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action actOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'tg 11/6/2009 16:58'!
open: aRenderable
	^ ( self windowFor: aRenderable ) openInWorld! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 11/8/2009 21:48'!
renderActionListPresentation: anActionListPresentation 
	| items list toShow container button buttonModel |
	toShow := anActionListPresentation displayValue.
	items := toShow isCollection ifTrue: [toShow] ifFalse: [OrderedCollection with: toShow].
	container := self emptyMorph.
	anActionListPresentation allActions withIndexDo: [:each :index|
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: anActionListPresentation.
		buttonModel glamourAction: each.
		button := PluggableButtonMorph
					on: buttonModel
					getState: nil
					action: #execute
					label: #buttonLabel.
		container 
				addMorph: button
				fullFrame: (LayoutFrame
					fractions: ((0@0) corner: (1@0)) 
					offsets: (0 @ (index-1*24) corner: 0 @ (index*24)))
		].
	^ container! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 10/22/2009 19:42'!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId
			ifTrue: [ pane := self render: (aBrowser paneNamed: each id) ]
			ifFalse: [
				self
					renderCustomRow: each
					ofPane: aPane
					inUI: (pane := self emptyMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
				topFraction: currentSpanPosition / totalSpans offset: currentOffset;
				leftFraction: 0 offset: 0;
				bottomFraction: currentSpanPosition + each span / totalSpans offset: currentOffset + each size;
				rightFraction: 1 offset: 0;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	aMorph addPaneSplitters! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 10/22/2009 19:42'!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId
			ifTrue: [ pane := self render: (aBrowser paneNamed: each id) ]
			ifFalse: [
				self
					renderCustomColumn: each
					ofPane: aPane
					inUI: (pane := self emptyMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new 
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: currentOffset;
				bottomFraction: 1 offset: 0;
				rightFraction: currentSpanPosition + each span / totalSpans offset: currentOffset + each size;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	aMorph addPaneSplitters! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 10/22/2009 22:33'!
renderDiffPresentation: aDiffPresentation 
	| textMorph textModel |  
	textMorph := (DiffMorph from: aDiffPresentation displayValue first to: aDiffPresentation displayValue last)
"			onKeyStrokeSend: #keystroke:from: to: textModel;
"			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
"	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
"	^textMorph! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: ''!
renderFinder: aBrowser 
	| container |
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | container popPane.].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | container pushPane: (self render: ann pane) ].
	aBrowser panes
		do: [ :each | container pushPane: (self render: each) ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 11/8/2009 00:32'!
renderListPresentation: aListPresentation 
	| items list toShow listModel container search |
	toShow := aListPresentation displayValue.
	items := toShow isCollection ifTrue: [toShow] ifFalse: [OrderedCollection with: toShow].
	listModel := (aListPresentation isMultiple ifTrue: [GLMMultiListModel new] ifFalse: [GLMListModel new])
				glamourPresentation: aListPresentation;
				items: items;
				displaySelector: aListPresentation format;
				searchBlock: aListPresentation searchStrategy;
				filterBlock: aListPresentation filterStrategy;
				yourself.
	container := self emptyMorph.
	list := aListPresentation isMultiple
				ifTrue: [
					PluggableListMorphOfMany
						on: listModel
						list: #displayedItems
						primarySelection: #selection
						changePrimarySelection: #selection:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: #menu
						keystroke: #keystroke:from:]
				ifFalse: [
					PluggableListMorph
						on: listModel 
						list: #displayedItems 
						selected: #singleSelection 
						changeSelected: #singleSelection: 
						menu: #menu
						keystroke: #keystroke:from: ].
	list
		color: Color white;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getMenuSelector: #menu:;
		alwaysShowScrollBars: false;
		keystrokeActionSelector: #keystroke:from:;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	self installActionsOnUI: listModel fromPresentation: aListPresentation.
	listModel onSelection: [:selection | aListPresentation selection: selection].
	aListPresentation allowsInput ifTrue: [
		search := UITheme current
			newTextEntryIn: nil
			for: listModel
			get: #searchText
			set: #searchText:
			class: String
			getEnabled: #searchEnabled
			help: 'Search Input'.
		search layoutFrame: (LayoutFrame
			fractions: (0 @ 1 corner: 1 @ 1) 
			offsets: (0 @ -24 corner: 0 @ 0)).
		list layoutFrame bottomOffset: -24.
		container addMorphBack: search ].
	container addMorphBack: list.
	aListPresentation when: GLMContextChanged do: [:ann | 
		ann property = #selection ifTrue: [listModel selectItem: ann value ]].
	aListPresentation when: GLMPresentationUpdated do: [:ann | 
		toShow := aListPresentation displayValue.
		items := toShow isCollection ifTrue: [toShow] ifFalse: [OrderedCollection with: toShow].
		listModel items: items ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 11/5/2009 15:58'!
renderMagrittePresentation: anAsMorphPresentation 
	| toShow description magritteMorph scrollPane |
	toShow := anAsMorphPresentation displayValue.
	description := (anAsMorphPresentation magritteDescription glamourValue: toShow) copy.
	description morphClass: MASilentContainerMorph.
	magritteMorph := (description asMorphOn: toShow)
		addButtons;
		morph.
	scrollPane := GLMScrollPaneForHResize new.
	scrollPane scroller
		addMorph: magritteMorph;
		layoutChanged.
	magritteMorph width: scrollPane width.
	^ scrollPane! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/29/2009 18:06'!
renderMondrianPresentation: aMondrianPresentation 
	 
	| canvas view canvasScrollPane | 
	view := MOViewRenderer new.
	aMondrianPresentation renderOn: view. 
	canvas := MOCanvas new. 
	canvas root: view root.
	canvas announcer
		when: MOFigureSelection
		do: [ :ann | aMondrianPresentation selection: ann element model ].
	canvasScrollPane := ScrollPane new.
	canvasScrollPane scroller addMorph: canvas.	
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	^ canvasScrollPane! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'lr 11/7/2009 11:42'!
renderMorphPresentation: aMorphPresentation 
	^ aMorphPresentation displayValue! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 11/5/2009 19:47'!
renderPane: aPane 
	| container |
	container := self emptyMorph.
	aPane whenMatchingPresentationsChanged: [:ann |
		container removeAllMorphs;
				addMorph: (self renderPresentationsOf: aPane)
				fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
				adoptPaneColor: container paneColor.
				window fullBounds.
				window refreshHorizontalScollbars ].
	container
		addMorph: (self renderPresentationsOf: aPane)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
		 adoptPaneColor: container paneColor.
	^ container! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 11/5/2009 16:14'!
renderPresentationsOf: aPane
	| presentations tabs title index | 
	presentations := aPane matchingPresentations.
	presentations isEmpty ifTrue: [ ^ self emptyMorph ].
	presentations size = 1 ifTrue: [ ^ self render: presentations first ].
	tabs := LazyTabGroupMorph new. 
	tabs 
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont;
		onPageIndexChange: [:i | aPane lastActivePresentation: (aPane matchingPresentations at: i) ].
	presentations do: [ :each | 
		title := each hasTitleIcon 
			ifTrue: [ UITheme current newImageIn: tabs form: each titleIconValue ]
			ifFalse: [ each titleValue ].
		tabs
			addLazyPage: [ self render: each ]
			label:  title ].
	index := 1.
	presentations withIndexDo: [:each :i | 
		aPane lastActivePresentation notNil and: [
			each title = aPane lastActivePresentation title ifTrue: [index := i]]].
	tabs selectedPageIndex: index.
	^ tabs! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 11/5/2009 19:35'!
renderTableLayoutBrowser: aBrowser 
	| container |
	container := self emptyMorph.
	aBrowser cell isRow
		ifTrue: [
			self
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: [
			self
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/14/2009 15:53'!
renderTextPresentation: aTextPresentation 
	| textMorph toShow textModel | 
	toShow := aTextPresentation formatedDisplayValue. 
	textModel := GLMTextModel new
			text: toShow;
			glamourPresentation: aTextPresentation;
			highlightSmalltalk: aTextPresentation highlightSmalltalk;
			highlightSmalltalkContext: aTextPresentation highlightSmalltalkContext.
	textMorph := (PluggableShoutMorph
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
			onKeyStrokeSend: #keystroke:from: to: textModel;
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
	^textMorph! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 9/28/2009 11:11'!
renderToolbarForBrowser: aBrowser inWindow: aWin
	| dock tools |
	dock := aWin newToolDockingBar.
	tools := aWin newToolbar: ((aBrowser allActions select: [:each | each hasIcon]) collect: [:each |
		aWin
			newButtonFor: each
			getState: nil
			action: #actOn:
			arguments: {aBrowser}
			getEnabled: nil
			labelForm: each icon
			help: each title ]).
	dock addMorphBack: tools.
	^ dock! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'lr 11/7/2009 14:32'!
renderTreePresentation: aTreePresentation 
	| treeMorph treeModel search container amountFilteringButton |
	treeModel := GLMTreeMorphModel new glamourPresentation: aTreePresentation.
	container := self emptyMorph.
	treeMorph := MorphTreeMorph new
						on: treeModel
						list: #roots
						multiSelection: aTreePresentation isMultiple.
	treeMorph
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: #square;
		borderStyle: (BorderStyle inset width: 1);
		autoDeselect: true;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		yourself.
	aTreePresentation allowsInput ifTrue: [
		search := UITheme current 
			newTextEntryIn: nil
			for: treeModel
			get: #inputText
			set: #inputText:
			class: String
			getEnabled: #inputTextEnabled
			help: 'Search Input'.
		search layoutFrame: (LayoutFrame 
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ -24 corner: 0 @ 0)).
		treeMorph layoutFrame bottomOffset: -24.
		container addMorphBack: search ].
	aTreePresentation limitsAmount ifTrue: [
		amountFilteringButton := GLMMorphicLibrary 
			togglingButtonLabelled: 'There are hidden elements'
			pressed: false.
		amountFilteringButton layoutFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 24)).
		amountFilteringButton
			target: treeModel;
			actionSelector: #toggleAmountToFilterBy.
		treeMorph layoutFrame topOffset: 24.
		container addMorphBack: amountFilteringButton ].
	container addMorphBack: treeMorph.
	self installActionsOnUI: treeModel fromPresentation: aTreePresentation.
	treeModel onSelection: [ :selection | 
		aTreePresentation selection: selection.
		aTreePresentation selectionPath: (treeModel selectionPath
			collect: [ :each | each item ]) ].
	treeMorph vShowScrollBar.
	aTreePresentation when: GLMContextChanged do: [ :ann |
		ann property = #selection ifTrue: [ treeModel explicitSelection: ann value ] ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'tg 11/6/2009 17:04'!
simulate: aRenderable
	^ ( self windowFor: aRenderable ) 
		newBounds: (0@0 extent: 800@600);
		layoutChanged! !

!GLMMorphicRenderer methodsFor: 'factory' stamp: 'a'!
theme
	^ UITheme current! !

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'tg 11/6/2009 20:09'!
windowFor: aRenderable
	| dock offset |
	window := GlamorousSystemWindow new.
	window model: aRenderable; setLabel: aRenderable titleValue.
	aRenderable allActions notEmpty ifTrue: [
		dock := self renderToolbarForBrowser: aRenderable inWindow: window.
		offset := dock minExtent y.
		window
				addMorph: dock
				fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ offset)) ].
	window
			addMorph: 	(self render: aRenderable)
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@offset corner: 0 @ 0)).
	aRenderable colorValue ifNotNil: [window paneColor: aRenderable colorValue].
	^ window! !

MorphTreeModel subclass: #GLMTreeMorphModel
	instanceVariableNames: 'roots glamourPresentation childrenBlock onSelection displayFormat tagsToFilterBy announcer inputText amountToFilterBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphModel commentStamp: 'alain.plantec 9/8/2009 15:22' prior: 0!
ClassTree new openOn: Collection
!

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/6/2009 00:53'!
allKeystrokeActions
	^ self glamourPresentation allActions select: [:action | action hasShortcut ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/10/2009 01:53'!
allMenuActions
	^ self glamourPresentation allActions select: [:action | action hasTitle ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/1/2009 23:53'!
amountToFilterBy
	^ amountToFilterBy ifNil: [self glamourPresentation amountToShow]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 12:05'!
amountToFilterBy: aNumber 
	amountToFilterBy := aNumber! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:17'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:16'!
announcer
	^ announcer ifNil: [announcer := Announcer new].! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:24'!
childrenBlock
	^ childrenBlock ifNil: [ childrenBlock := self glamourPresentation children isNil 
		ifFalse: [self glamourPresentation children] ifTrue: [OrderedCollection new] ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
childrenBlock: aBlock
	childrenBlock := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:23'!
displayFormat
	^ displayFormat ifNil: [displayFormat := self glamourPresentation format]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
displayFormat: aBlock 
	displayFormat := aBlock ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 00:11'!
doSearchOrFilter
	inputText isEmptyOrNil
		ifTrue: [ self resetInput ]
		ifFalse:[ 
			self glamourPresentation allowsFilter 
				ifTrue: [ self executeFilter ]
				ifFalse: [ self executeSearch ] ].
! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 01:25'!
executeFilter
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/29/2009 23:18'!
executeSearch
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 08:41'!
explicitSelection: anObject

	self glamourPresentation isMultiple 
		ifTrue: [self selectMultipleItems: anObject ]
		ifFalse: [self selectItem: anObject ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 01:44'!
filteredRoots
	| filtered |
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation
	^ glamourPresentation! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/28/2009 01:24'!
inputText
	^ inputText ifNil: [inputText := '']! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 23:05'!
inputText: anObject
	inputText := anObject.
	self doSearchOrFilter! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 16:29'!
inputTextEnabled
	^ true! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 00:58'!
keyStroke: aCharacter from: aTreeMorph 
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aCharacter] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/2/2009 01:04'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring the #shifted boolean"
	self selectedItem ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
nodeModelFor: anObject
	^ (GLMTreeMorphNodeModel with: anObject) containerTree: self; yourself! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/8/2009 21:40'!
onSelection: aBlock
	onSelection := aBlock! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 00:11'!
resetInput
! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:00'!
resetTagsToFilterBy
	tagsToFilterBy := OrderedCollection new.
	self changed: #roots.! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 01:24'!
roots
	| filtered |
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filtered size]) and: [
			filtered notEmpty]) ifTrue: [
		filtered := filtered first: self amountToFilterBy ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 11:01'!
selectItem: anObject
	(self selectedItem notNil and: [ self selectedItem item == anObject ]) ifTrue: [ ^ self ].
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			each item = anObject ifTrue: [
				self silentNoteNewSelection: each.
				^ self]]]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 10:07'!
selectMultipleItems: aCollection
	self flag: 'check this'.
	(self selectionSet size = aCollection size and: [ self selectionSet = aCollection asSet ]) ifTrue: [ ^ self ].
	self selectionSet: aCollection asSet.
	self changed: #selection.
"	self roots do: [:eachRoot | eachRoot withContentsDo: [:each |
		(aCollection includes: each item) ifTrue: [
			amountToSelect := amountToSelect - 1.
			self silentNoteNewSelection: each.
			amountToSelect > 0 ifFalse: [
				^ self ]]]]"! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/4/2009 13:36'!
selectionPath: path
	super selectionPath: path.
"	x = self  ifTrue: [^ self]."
	path isNil ifFalse: [
		onSelection ifNotNil: [onSelection value: (path last isNil ifTrue: [nil] ifFalse: [path last item])].
	].! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/4/2009 15:02'!
selectionPath: path selectionSet: set
	super selectionPath: path selectionSet: set.
	path isNil ifFalse: [
		onSelection ifNotNil: [onSelection value: (set flatCollect: #yourself)].
	].! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/30/2009 14:01'!
shouldFilterByAmount
	^ self amountToFilterBy notNil and: [self amountToFilterBy isZero not]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:29'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/30/2009 01:16'!
shouldFilterByText
	^ self glamourPresentation allowsFilter and: [ self inputText notEmpty ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/2/2009 01:20'!
silentNoteNewSelection: x
	self flag: 'check this out'.
	x expandParentPath.
"	self selectionPath: x path."! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 03:59'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 14:03'!
toggleAmountToFilterBy
	self amountToFilterBy notNil ifTrue: 
		[ self amountToFilterBy isZero 
			ifTrue: [ amountToFilterBy := self glamourPresentation amountToShow ]
			ifFalse: [ amountToFilterBy := 0 ].
		self changed: #roots ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 01:19'!
toggleFilteringByTag: aTag 
	(self shouldFilterByTag: aTag) 
		ifTrue: [self tagsToFilterBy remove: aTag ]
		ifFalse: [self tagsToFilterBy add: aTag].
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:18'!
when: anAnnouncement do: aBlock
	self announcer when: anAnnouncement do: aBlock ! !

StandardWindow subclass: #GlamorousSystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GlamorousSystemWindow methodsFor: 'building' stamp: ''!
buildWindowMenu
	^ self model actions isEmpty
		ifTrue: [ super buildWindowMenu ]
		ifFalse: [
			self model actions
				inject: (super buildWindowMenu
					addLine;
					yourself)
				into: [ :menu :action |
					menu
						add: action title target: action selector: #actOn: argument: self model;
						yourself ] ]! !

!GlamorousSystemWindow methodsFor: 'building' stamp: 'tg 11/5/2009 15:56'!
extent: aPoint 
	super extent: aPoint.
	self fullBounds.
	self refreshHorizontalScollbars.! !

!GlamorousSystemWindow methodsFor: 'building' stamp: 'tg 11/5/2009 15:54'!
refreshHorizontalScollbars
	self allMorphsDo: 
		[ :morph | 
		(morph isKindOf: GLMScrollPaneForHResize) ifTrue: [ morph scroller submorphs anyOne width: morph scroller width - 20 ] ]! !

Announcement subclass: #GLMActionAnnouncement
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMActionAnnouncement classSide methodsFor: 'instance creation' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	^self new action: anAction; yourself! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action
	^action! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	action := anAction! !

GLMActionAnnouncement subclass: #GLMKeyStroke
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMActionAnnouncement subclass: #GLMMenuInvoked
	instanceVariableNames: 'menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMenuInvoked classSide methodsFor: 'as yet unclassified' stamp: 'jre 7/31/2009 15:24'!
action: anAction on: aMenuMorph 
	^self new initializeAction: anAction on: aMenuMorph! !

!GLMMenuInvoked methodsFor: 'initialization' stamp: 'jre 7/31/2009 15:43'!
initializeAction: anAction on: aMenuMorph 
	self action: anAction.
	menuMorph := aMenuMorph! !

!GLMMenuInvoked methodsFor: 'accessing' stamp: 'jre 7/31/2009 15:43'!
menuMorph
	^menuMorph! !

GLMActionAnnouncement subclass: #GLMMenuItemSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

ScrollPane subclass: #GLMScrollPaneForHResize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMScrollPaneForHResize commentStamp: 'tg 10/2/2009 00:42' prior: 0!
This class has no implementation. It is only useful for identifying the scroll panes that need to resize the content horizontally (to stretch their size), like in the case of the magritte forms. It is instantiated in the MorhpicRenderer and queried for in the GlamorousSystemWindow.!

Object subclass: #GLMMorphicLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicLibrary classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/30/2009 01:40'!
togglingButtonLabelled: aString pressed: aBoolean
	| button oldLabel m |
	button := SimpleButtonMorph new.
	(oldLabel := button findA: StringMorph) ifNotNil: [ oldLabel delete ].
	m := StringMorph 
		contents: aString
		font: (LogicalFont 
				familyName: UITheme current buttonFont familyName
				pointSize: UITheme current buttonFont pointSize - 2).
	button extent: (m width + 6) @ m height.
	m position: 3 @ 0.	"button center - (m extent // 2)"
	m lock.
	button
		addMorph: m;
		borderStyle: (BorderStyle inset width: 1);
		borderColor: Color gray;
		useRoundedCorners.
	aBoolean 
		ifFalse: 
			[ m color: Color white.
			button color: Color gray ]
		ifTrue: 
			[ m color: Color darkGray.
			button color: Color veryLightGray ].
	^ button! !

TabGroupMorph subclass: #LazyTabGroupMorph
	instanceVariableNames: 'lazyPages onPageIndexChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:12'!
addLazyPage: aBlock label: aStringOrMorph
	self lazyPages add: aBlock.
	self tabSelectorMorph addTab: aStringOrMorph! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:44'!
addPage: aMorph 
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^self pages add: aMorph.! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 8/7/2009 10:16'!
addPage: aMorph at: anIndex
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^self pages at: anIndex put: aMorph! !

!LazyTabGroupMorph methodsFor: 'initialization' stamp: 'jre 8/7/2009 10:11'!
initialize
	super initialize.
	lazyPages := OrderedCollection new.
	pageMorphs := Dictionary new.
! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:12'!
lazyPages

	^lazyPages! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'tg 10/18/2009 19:36'!
onPageIndexChange
	^ onPageIndexChange ifNil: [[]]! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'tg 10/18/2009 19:36'!
onPageIndexChange: anObject
	onPageIndexChange := anObject! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 8/7/2009 10:16'!
pageAt: index
	^self pages at: index ifAbsent: [ self addPage: (self lazyPages at: index) value at: index]! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'tg 10/18/2009 19:38'!
updatePageIndex: index
	"Change to the given page index."

	|p|
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pageAt: index)]
		ifFalse: [self contentMorph
				replaceSubmorph: p
				by: (self pageAt: index)].
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor.
	self onPageIndexChange value: index! !
